runtest: support passing options over to the shell
[platform/upstream/automake.git] / runtest.in
1 #!@AM_TEST_RUNNER_SHELL@
2 #
3 # Copyright (C) 2012 Free Software Foundation, Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2, or (at your option)
8 # any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 # Run an Automake test from the command line.
19 # Usage:
20
21 set -e; set -u
22
23 : ${AM_TEST_RUNNER_SHELL='@AM_TEST_RUNNER_SHELL@'}
24 : ${AM_PROVE_CMD='prove'}
25 : ${AM_PROVEFLAGS='--merge --verbose'}
26 : ${srcdir='@srcdir@'}
27
28 error () { echo "$0: $*" >&2; exit 255; }
29
30 # Some shell flags should be passed over to the test scripts.
31 shell_opts=
32 while test $# -gt 0; do
33   case $1 in
34     --help)
35        echo "Usage: $0 [SHELL-OPTIONS] TEST [TEST-OPTIONS]"
36        exit $?
37        ;;
38     -o)
39        test $# -gt 1 || error "missing argument for option '-o'"
40        shell_opts="-o $2"
41        shift
42        ;;
43     -*)
44        # Assume it is an option to pass through to the shell.
45        shell_opts=$1;;
46      *)
47        break;;
48   esac
49   shift
50 done
51
52 test $# -gt 0 || error "missing argument"
53
54 tst=$1; shift
55
56 case $tst in
57    *.sh) wrapper () { exec "$@"; };;
58   *.tap) wrapper () { exec "$AM_PROVE_CMD" $AM_PROVEFLAGS -e "$@"; };;
59       *) error "test '$tst' has an unrecognized extension";;
60 esac
61
62 case $tst in
63   /*) ;;
64    *) if test -f ./$tst; then
65         tst=./$tst
66       # Support for VPATH build.
67       elif test -f $srcdir/$tst; then
68         tst=$srcdir/$tst
69       else
70         error "could not find test '$tst'"
71       fi
72       ;;
73 esac
74
75 wrapper "$AM_TEST_RUNNER_SHELL" $shell_opts "$tst" "$@"
76 error "dead code reached"